// BEGIN FLOCK GPL
// 
// Copyright Flock Inc. 2005-2006
// http://flock.com
// 
// This file may be used under the terms of of the
// GNU General Public License Version 2 or later (the "GPL"),
// http://www.gnu.org/licenses/gpl.html
// 
// Software distributed under the License is distributed on an "AS IS" basis,
// WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
// for the specific language governing rights and limitations under the
// License.
// 
// END FLOCK GPL
//

var gErrorCount = 0;
var gTimeout;

function blogTriggerPublish(blog, title, html, editURI, postid, atomid, newPost) {
  var date = new Date();
  window.gB = blog;
  // Clean the HTML
  // Livejournal doesn't like <br />
  if (html)
    html = html.replace(/<br \/>/g, '<br/>');
  var notifications = flock.blog.service.getNotifications();
  dump(notifications);

  if(newPost) {
    var listener = BlogPublishListener;
    blog.newPost(listener, title, html, date, true, notifications);
  }
  else {
    dump(postid+" *** "+editURI+" *** "+atomid+"\n");
    var listener = BlogEditListener;
    blog.editPost(listener, postid, title, html, date, true, editURI, atomid, notifications);
  }
}

var blogSetCategories = {
  exec: function(aBlog, aPostid, aCategories) {
    if (aCategories.length>0 && aBlog.name=="movabletype") {
      aBlog.setPostCategories(this, aPostid, aCategories);
    }
  },
  onResult: function(aResult) {
    dump('BLOG: Categories ok');
    window.opener.success = true;
    window.clearTimeout(gTimeout);
    // HACK!
    $('cancel-button').click();
  }
}

function flock_blogEditorGetCategoryIdArray() {
  // XXX ERWAN: Temporary passing it as a string to workaround xpcom parameter
  // passing pb
  // var rval = new Array();
  var rval = "";
  var categories = opener.$("flock-blog-categories").childNodes;
  for(var i=0;i<categories.length;++i) {
    var category = categories.item(i);
    if(!category.selected) continue;
    if (rval != "")
      rval = rval + "|";
    var categoryId = category.firstChild.getAttribute("categoryId");
    rval = rval + categoryId;
  }
  return rval;
}

var BlogPublishListener = {
  failCount: 0,
  selectedPost: null,
  onResult: function(aResult) {
    var rdfService = Components.classes["@mozilla.org/rdf/rdf-service;1"].
               getService(Components.interfaces.nsIRDFService);
    // dump_rdf(aResult);
    var newPostID;

    var subject = rdfService.GetResource("http://www.flock.com/rdf/newpost");
    var predicate = rdfService.GetResource("http://www.flock.com/rdf/postid");
    var target = aResult.GetTarget(subject, predicate, true);
    if (target instanceof Components.interfaces.nsIRDFLiteral){
      newPostID = target.Value;
    }
    dump("PostID: "+newPostID+"\n");

    predicate = rdfService.GetResource("http://www.flock.com/rdf/permalink");
    target = aResult.GetTarget(subject, predicate, true);
 
    // Set cateogories
    var categories = flock_blogEditorGetCategoryIdArray();
    if (categories != ""){
      blogSetCategories.exec(window.gB, newPostID, categories);
    }
    else {
      window.opener.success = true;
      // HACK!
      $('cancel-button').click();
    }
    window.clearTimeout(gTimeout);
  },

  onFault: function (fault) {
    if (gErrorCount < 2){
      dump("Publication error, try again...\n");
      gErrorCount = gErrorCount + 1;
      publish_onload(); // Try again
    }
    else {
      var strbundle = document.getElementById("blogStringBundle");
      var msg = strbundle.getString("flock.blog.publishing.fault");
      window.clearTimeout(gTimeout);
      this.showErrorUI(msg);
    }
  },

  onError: function (errorMsg) {
    if (gErrorCount < 2){
      dump("Publication error, try again...\n");
      gErrorCount = gErrorCount + 1;
      publish_onload(); // Try again
    }
    else {
      var strbundle = document.getElementById("blogStringBundle");
      var msg = strbundle.getString("flock.blog.publishing.error");
      window.clearTimeout(gTimeout);
      this.showErrorUI(msg);
    }
  },
    
  showErrorUI: function aMessage(aMsg) {
    try {
      var strbundle = document.getElementById("blogStringBundle");
      $('publishing-title').firstChild.nodeValue = aMsg;
      $('cancel-button').setAttribute('label', strbundle.getString("flock.blog.ok"));
      $('cancel-button').focus();
      $('blog-publishing-progressmeter').hidden = true;
    } catch (ex) {
      dump (ex + '\n');
    }
  }
};

var BlogEditListener = {
  failCount: 0,
  selectedPost: null,
  onResult: function(result) {
    window.clearTimeout(gTimeout);
    if(result) {
      window.opener.success = true;
      // HACK!
      $('cancel-button').click();
    }
    else {
      $('cancel-button').click();
    }
  },

  onFault: function (fault) {
    if(this.failCount++<2) {
      publish_onload(); // Try again
    }
    else {
      var strbundle = document.getElementById("blogStringBundle");
      var msg = strbundle.getString("blog_publish_fault");
      window.clearTimeout(gTimeout);
      alert(msg + "\n\n" + fault.faultString);
    }
  },

  onError: function (errorMsg) {
    var strbundle = document.getElementById("blogStringBundle");
    var msg = strbundle.getString("flock.blog.publishing.error");
    window.clearTimeout(gTimeout);
    alert(msg);
  }
};

function timeOutError() {
  var strbundle = document.getElementById("blogStringBundle");
  msg = strbundle.getString("flock.blog.publishing.timeError")+"\n";
  alert(msg);
  $('cancel-button').click();
};

function publish_onload() {
  var params  = window.arguments[0];
  gTimeout = window.setTimeout("timeOutError()", 20000);
  dump("EditURI: "+params.editURI);
  blogTriggerPublish(params.blog, params.title, params.html,
                     params.editURI, params.postid, params.atomid, params.newPost);
}

