// no ui code should be loaded into services
const FLOCK_DEBUG = 1;

var flock = {/*{{{*/
};/*}}}*/

try {
    var working_debug = debug;
} catch (e) {
    var working_debug = dump;
}

flock.debug = function () {/*{{{*/
    if (!FLOCK_DEBUG) return;
	var out = ''
	if (arguments.length > 1) {
		for (var i = 0;i < arguments.length;i++) {
			out += arguments[i] + " : ";
		}
	} else {
		out = "DEBUG : "+arguments[0];
	}
	working_debug(out+"\n");
}/*}}}*/
flock.dumpvar = function (aObj) {/*{{{*/
	for (p in aObj) {
		try {
			working_debug(p + ' :: ' + aObj[p] + '\n'); 
			if (typeof aObj[p] == 'aObject') { 
				for (q in aObj[p]) { 
					working_debug(p + '.' + q + ' :: ' + aObj[p][q] + '\n'); 
				} 
			}
		} catch(e) {
			continue;
		}
	}
};/*}}}*/
var XXX = flock.debug;
var dd = flock.dumpvar;
flock.deprecated = function (aMsg, aVersion) {/*{{{*/
    var msg = aMsg;
    if (aVersion) msg += " -- removal scheduled for version "+aVersion;
    flock.debug('DEPRECATED', msg);
}/*}}}*/
flock.load = function (aSpec) {/*{{{*/
    if (aSpec.substr(0,6) == "flock.") {
        var converted = aSpec.replace(/\./g,"/");
        aSpec = "chrome://browser/content/" + converted + ".js";
    }
    if (flock.load.loaded.indexOf(aSpec) != -1) {
        return;
    }
    XXX('flock.load', aSpec);
    var loader = Components.classes['@mozilla.org/moz/jssubscript-loader;1']
        .getService(Components.interfaces.mozIJSSubScriptLoader);
    loader.loadSubScript(aSpec);
    flock.load.loaded.push(aSpec);
}/*}}}*/
flock.load.loaded = [];
flock.require = flock.load;

function flock_escape(aStr){/*{{{*/
	txt='';
	for (i=0; i < aStr.length; i++) {
		if (aStr.charCodeAt(i) < 127) {
			txt += escape(aStr[i]);
		}
		else {
			txt += aStr[i];
		}
	}
	return txt;
}/*}}}*/
function isBoolean(a) {/*{{{*/
    return typeof a == 'boolean';
}/*}}}*/
function isFunction(a) {/*{{{*/
    return typeof a == 'function';
}/*}}}*/
function isNull(a) {/*{{{*/
    return typeof a == 'object' && !a;
}/*}}}*/
function isNumber(a) {/*{{{*/
    return typeof a == 'number' && isFinite(a);
}/*}}}*/
function isObject(a) {/*{{{*/
    return (a && typeof a == 'object') || isFunction(a);
}/*}}}*/
function isString(a) {/*{{{*/
    return typeof a == 'string';
}/*}}}*/

function argsToArray(aArgs, aOffset) {/*{{{*/
    if (!aOffset) aOffset = 0;
    var out = [];
    for (var i = aOffset; i < aArgs.length; ++i) {
        out.push(aArgs[i]);
    }
    return out;
}/*}}}*/

function catchWrapper(aFunc) {/*{{{*/
    var wrappedFunc = function () {
        try {
            aFunc.apply(this, arguments);
        }
        catch (e) {
            dd(e);
        }
    }
    return wrappedFunc;
}/*}}}*/

// Services
function flock_getService(aClassId, aIface) {/*{{{*/
    if (isString(aIface)) {
        XXX("IFACE",aIface);
        aIface = Components.interfaces[aIface];
    }
    return Components.classes[aClassId].getService(aIface);
}/*}}}*/
// XXX andy: maybe this should be in dnd.js
function flock_getDragService() {/*{{{*/
    return flock_getService('@mozilla.org/widget/dragservice;1',
                            "nsIDragService");
}/*}}}*/
function flock_getFavoritesService() {/*{{{*/
    return flock_getService(
        '@mozilla.org/rdf/datasource;1?name=flock-favorites',
        "flockIFavoritesService");
}/*}}}*/
// XXX andy: maybe we should make a feeds.js
function flock_getFeedService() {/*{{{*/
    return flock_getService('@flock.com/feed-service;1',
                            "flockIFeedService");
}/*}}}*/
function flock_getObserverService() {/*{{{*/
    return flock_getService('@mozilla.org/observer-service;1',
                            "nsIObserverService");
}/*}}}*/
function flock_getPrefService() {/*{{{*/
    return flock_getService('@mozilla.org/preferences-service;1',
                            "nsIPrefBranch");
}/*}}}*/
// XXX andy: maybe this should be in rdf.js or something?
function flock_getRDFService() {/*{{{*/
    return flock_getService('@mozilla.org/rdf/rdf-service;1',
                            "nsIRDFService")
}/*}}}*/
function flock_getStringBundleService() {/*{{{*/
    return flock_getService("@mozilla.org/intl/stringbundle;1",
                            "nsIStringBundleService");
}/*}}}*/
function flock_getWindowMediatorService() {/*{{{*/
    return flock_getService("@mozilla.org/appshell/window-mediator;1",
                            "nsIWindowMediator");
}/*}}}*/


// DataSources
function flock_getFavoritesDataSource() {/*{{{*/
    return flock_getRDFService().GetDataSource('rdf:flock-favorites');
}/*}}}*/
function flock_getHistoryDataSource() {/*{{{*/
    return flock_getRDFService().GetDataSource('rdf:history');
}/*}}}*/


// StringBundle
function flock_getStringBundle(aChromeUrl) {/*{{{*/
    return flock_getStringBundleService().createBundle(aChromeUrl);
}/*}}}*/
function flock_getBundler(aChromeUrl) {/*{{{*/
    return function (aStr) {
        bundle = flock_getStringBundle(aChromeUrl);
        // XXX andy: maybe we want to pull this outside the function?
        //           not sure which way is most efficient
        return bundle.GetStringFromName(aStr);
    }
}/*}}}*/


// RDF
// XXX andy: maybe these should be pulled out to rdf.js or whatever
function flock_getRDFResource(aStr) {/*{{{*/
	return flock_getRDFService().GetResource(aStr);
}/*}}}*/
function flock_clearDataSources(aElement) {/*{{{*/
    var sources = aElement.database.GetDataSources();
    while (sources.hasMoreElements()) {
        var source = sources.getNext();
        aElement.database.RemoveDataSource(source);
    }
}/*}}}*/
function flock_setDataSources(aElement) {/*{{{*/
    flock_clearDataSources(aElement);
    for (var i = 1; i < arguments.length; ++i) {
        XXX(arguments[i]);
        aElement.database.AddDataSource(arguments[i]);
    }
}/*}}}*/
// DEPRECATED: use flock_getRDFResource
function flock_getResource(aStr) {/*{{{*/
    XXX('DEPRECATED','flock_getResource','use flock_getRDFResource instead');
    return flock_getRDFResource(aStr);
}/*}}}*/


// Preferences
function flock_clearPref(aKey) {/*{{{*/
	var prefService = flock_getPrefService();
	prefService.clearUserPref(aKey);
	prefService.deleteBranch(aKey);
}/*}}}*/
function flock_getCharPref(aKey) {/*{{{*/
    try {
        return flock_getPrefService().getCharPref(aKey);
    } catch (e) {
        return;
    }
}/*}}}*/
function flock_setCharPref(aKey, aValue) {/*{{{*/
    flock_getPrefService().setCharPref(aKey, aValue);
}/*}}}*/
function flock_getIntPref(aKey) {/*{{{*/
    try {
        return flock_getPrefService().getIntPref(aKey);
    } catch (e) {
        return;
    }
}/*}}}*/
function flock_setIntPref(aKey, aValue) {/*{{{*/
    flock_getPrefService().setIntPref(aKey, aValue);
}/*}}}*/
function flock_getBoolPref(aKey) {/*{{{*/
    try {
        return flock_getPrefService().getBoolPref(aKey);
    } catch (e) {
        return;
    }
}/*}}}*/
function flock_setBoolPref(aKey, aValue) {/*{{{*/
    flock_getPrefService().setBoolPref(aKey, aValue);
}/*}}}*/
// DEPRECATED: use flock_getCharPref
function flock_getPref(aKey) {/*{{{*/
    XXX('DEPRECATED','flock_getPref','use flock_getCharPref instead');
    return flock_getCharPref(aKey);
}/*}}}*/
// DEPRECATED: use flock_setCharPref
function flock_setPref(aKey) {/*{{{*/
    XXX('DEPRECATED','flock_setPref','use flock_setCharPref instead');
    flock_setCharPref(aKey);
}/*}}}*/

flock.prefs = {};
flock.prefs.setCharPref = flock_setCharPref;
flock.prefs.getCharPref = flock_getCharPref;

function flock_parseDate(datestr)
{
    var date = null;

    datestr = datestr.replace(/^\s*|\s*$/g, '');

    var dateval = Date.parse(datestr);

    if (dateval) {
        date = new Date(dateval);
    } else {
        /* this is a parser for the W3C subset of ISO 8601 dates
         * http://www.w3.org/TR/NOTE-datetime
         */
        const re_iso8601 = new RegExp(
            "^(\\d{4})(-(\\d{2,3})(-(\\d{2})" +
            "(T(\\d{2}):(\\d{2})(:(\\d{2})(\\.(\\d+))?)?" +
            "(Z|(([-+])(\\d{2}):(\\d{2})))?)?)?)?$");

        var m = datestr.match(re_iso8601);

        if (m) {
            date = new Date(Date.UTC(m[1]))

            m[3]  && date.setUTCMonth   (m[3] - 1);
            m[5]  && date.setUTCDate    (m[5]);
            m[7]  && date.setUTCHours   (m[7]);
            m[8]  && date.setUTCMinutes (m[8]);
            m[10] && date.setUTCSeconds (m[10]);

            m[12] && date.setUTCMilliseconds(('0.' + m[12]) * 1000);

            if (m[14]) {
                var tz_off = m[16] * 60 + Number(m[17]);
                tz_off *= m[15] == '-' ? -1 : 1;
                tz_off *= 60 * 1000;

                date.setTime(date.getTime() - tz_off);
            }

        }
    }

    return date;
/*
    if (date)
        return date.toString();
    else
        return null;
*/
}/*}}}*/

flock.xpcom = {
};

flock.xpcom.getService = function (aClass, aInterface) {
    if (typeof aInterface == "string") {
        aInterface = Components.interfaces[aInterface];
    }
    return Components.classes[aClass].getService(aInterface);
};
// Javascript Extensions
function $(aElementName) {/*{{{*/
	return document.getElementById(aElementName);
}/*}}}*/
function $$(aElementName) {/*{{{*/
	return top.document.getElementById(aElementName);
}/*}}}*/

flock.browser = {/*{{{*/
    // what shall we do when all is gone?
    // sail on, sail on
    // sail on and on
};/*}}}*/

flock.browser.currentWindowIsMostRecent = function() {/*{{{*/
    return flock.browser.mostRecentNavigator == top;
};/*}}}*/

// flock.browser.currentUrl

flock.browser.__defineGetter__("mostRecentNavigator", function () {/*{{{*/
    return flock.xpcom.getService("@mozilla.org/appshell/window-mediator;1",
                            "nsIWindowMediator") 
                .getMostRecentWindow("navigator:browser");
});/*}}}*/

flock.xpcom.__defineGetter__('windowMediator', function () {/*{{{*/
    return flock.xpcom.getService(
        "@mozilla.org/appshell/window-mediator;1",
        "nsIWindowMediator"
    );
});/*}}}*/

flock.browser.parseQuery = function (aURL) {/*{{{*/
    var m = aURL.match(/.*\?(.*)/);
    if (!m) return {}
    var qs = m[1].split("&");
    var o = {};
    qs.forEach(function (aVal) {
        var kv = aVal.split("=");
        o[unescape(kv[0])] = unescape(kv[1]);
    });
    return o;
}/*}}}*/

function openFlockPreferences(aPane) {

//@line 372 "/cygdrive/K/tinderbuild/src/flock/mozilla/browser/components/flock/common/content/flocksafe.js"
    var opts = 'chrome,all,centerscreen';
//@line 374 "/cygdrive/K/tinderbuild/src/flock/mozilla/browser/components/flock/common/content/flocksafe.js"
    var windowsMediator = Components.classes["@mozilla.org/appshell/window-mediator;1"]
        .getService(Components.interfaces.nsIWindowMediator);
    var recent = windowsMediator.getMostRecentWindow("Browser:FlockPreferences");
    if(recent) {
        recent.focus();
        if(aPane) {
            var doc = recent.document;
            var pane = doc.getElementById(aPane);
            doc.documentElement.showPane(aPane);
        }
    }
    else {
        window.openDialog("chrome://browser/content/flock/preferences/preferences.xul", 
            "FlockPreferences", opts, aPane);
    }
}
