/*
     BEGIN FLOCK GPL
     
     Copyright Flock Inc. 2005-2006
     http://flock.com
     
     This file may be used under the terms of of the
     GNU General Public License Version 2 or later (the "GPL"),
     http://www.gnu.org/licenses/gpl.html
     
     Software distributed under the License is distributed on an "AS IS" basis,
     WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
     for the specific language governing rights and limitations under the
     License.
     
     END FLOCK GPL
*/

flock.require('flock.photo.photoCommon');

var gPageSize = 50;
var gFinishedQuery = false;
var gBrowseResult = null;
var gNumUploads = 0;

function flock_photoOpenProperties() {
    var selection = $("flock-photo-upload-slideybox").getSelection();
    if(selection && selection.length) {
        window.openDialog("photoProperties.xul", "_blank", "modal,close,centerscreen", selection);
    }
}

function flock_photoRemove() {
    var selection = $("flock-photo-upload-slideybox").getSelection();
    if(selection && selection.length) {
        for (var i = 0; i < selection.length; i++) {
	        selection[i].firstChild.removeMe();
        }
    }
    flock_updateSelectionUI();
}

function flock_getAllPhotoUploads() {
    var photouploads = document.getElementsByTagName('photoupload');
    var uploadsArray = Array();
    for (var i=1; i < photouploads.length; i++) {
        uploadsArray.push(photouploads[i]);
    }
    return uploadsArray;
}
////////////////////////////////////////////////////////////////////////////////////////
// Upload stuff
////////////////////////////////////////////////////////////////////////////////////////

const MCID = '@flock.com/photo-api-manager;1?';
const MIID = Components.interfaces.flockIPhotoAPIManager;

var gPhotoImportQ = new Array();
var gAPI = null;
var gAuthenticatedUser = null;
var gUploaderService = null;
var gPhotoMgrSvc = Components.classes[MCID].createInstance(MIID);

function flock_photoUploadTopbarLoad() {
	window.flock_photoUpload = flock_photoUpload;
	gUploaderService = flock.xpcom.getService(
        '@mozilla.org/rdf/datasource;1?name=flock-photo-uploads',
        'flockIPhotoUploadService'
    );
    gUploaderService.addListener(UploadListener);
    $("flock-photo-upload-slideybox").setListener(PhotoUploadScrolleyboxListener);
    flock_updateSelectionUI();
    if(flock_photoCount()) {
       //select the first child 
        $("flock-photo-upload-slideybox").childNodes.item(1).selected = true;
        $("flock-photo-upload-slideybox").childNodes.item(1).focus();
    }
}

function flock_photoUploadTopbarUnload() {
    gUploaderService.removeListener(UploadListener);
	flock_photoCommonUnload();
}

function flock_photoLoadTimer() {
    if(gPhotoImportQ.length==0) return;
    var requestObserver = gPhotoImportQ.pop();
    requestObserver.asyncCopier.asyncCopy(requestObserver, requestObserver.sinkFile);
}

////////////////////////////////////////////////////////////////////////////////////////
// UI Listeners
////////////////////////////////////////////////////////////////////////////////////////

var PhotoUploadScrolleyboxListener = {
    onDrop: function(aHoverChild, aSelection) {
        try {
        var svc = flock.photouploader.service;
        var hoverChild = aHoverChild;
        if(hoverChild) hoverChild = svc.getPhotoUpload(hoverChild.firstChild.id);
        for(var i=0;i<aSelection.length;++i) {
            var photo = aSelection[i].firstChild;
            dump("Adding photo upload " + photo.id + "\n");
            if(aHoverChild && aHoverChild.firstChild==photo) continue;
            svc.addPhotoUpload(hoverChild, svc.getPhotoUpload(photo.id));
        }
        }
        catch(e) {
            alert(e);
        }
    },
    onScrollRight: function() {
    },
    onScrollLeft: function() {
    },
    onSelect: function(aSelection) {
        if(flock.photouploader.service.isUploading) return;
        flock_updateSelectionUI();
        flock_showPhotoProps(aSelection);
    },
    onRemoveSelection: function(aSelection) {
        flock_photoPropertiesClearSelection();
        var svc = flock.photouploader.service;
        for(var i=0;i<aSelection.length;++i) {
            var child = aSelection[i].firstChild;
            dump(aSelection.length + " " + aSelection[i].nodeName + " " + child.nodeName + " onRemove Selection\n");
            svc.removePhotoUpload(child);
            flock_photoSetupImage();
        }
        
        if (!flock_getAllPhotoUploads().length) {
            $('flock-photo-success').setAttribute('hidden','true');
            $('flock-photo-real-instructions').removeAttribute('hidden');
            $('flock-photo-instructions').removeAttribute('hidden');
        }
    }
}

var UploadListener = {
    onUploadStart: function (aCurrentUpload, aCount, aMax) {
        flock_photoPropertiesClearSelection();
        $('bcasterPhotosSelected').setAttribute('disabled', true);
        $('photoAddFilesBtn').setAttribute('disabled', true);
        $('flockPhotoUploadProgress').setAttribute('value', 'Uploading ' + aCount + ' of ' + gNumUploads);
        $("flock-photo-upload-slideybox").scrollHome();
        flock_photoUploadDisable();
        $('flock-photo-upload-slideybox').selectAll();
        flock_photoPropertiesClearSelection();
        //flock_showPhotoProps($('flock-photo-upload-slideybox').getSelection());
        $("flock-photoprops-disable").hidden = false;
        $('bcasterHasPhotos').setAttribute('disabled', 'true');
        $('flock-photo-real-instructions').setAttribute('hidden','true');
        dump('onUploadStart\n');
    },
    onUpload: function (aCurrentUpload, aCount, aMax) {
    },
    onUploadAdd: function (aCurrentUpload) {
        flock_updateCommandState();
        if(flock_photoCount()==1) {
           //select the first child 
            $("flock-photo-upload-slideybox").childNodes.item(1).selected = true;
        }
    },
    onUploadRemove: function () {
        if(flock.photouploader.service.isUploading) return;
        flock_photoPropertiesClearSelection();
        try {
            flock_updateCommandState();
            flock_showPhotoProps($('flock-photo-upload-slideybox').getSelection());
        } catch (ex) {
            flock_photoSetupImage();
        }
    },
    onUploadComplete: function () {
        $('bcasterHasPhotos').setAttribute('label', 'Publish');
        $('bcasterHasPhotos').setAttribute('oncommand', 'flock_photoLaunchUpload();');
        $('bcasterHasPhotos').setAttribute('disabled', true);
        $('flockPhotoUploadProgress').removeAttribute('value');
        $('flock-photo-instructions').removeAttribute('hidden');
        $('photoAddFilesBtn').removeAttribute('disabled');
        $("flock-photoprops-disable").hidden = false;
        flock_photoSetupImage();
        flock_photoUploadEnable();
        $('flock-photo-success').removeAttribute('hidden');
        $('flock-photo-real-instructions').setAttribute('hidden','true');
        $('flock-photo-instructions').removeAttribute('hidden');
    },
    onUploadError: function (aUpload, aCount, aMax, aError) {
        // LOCALIZATION NOTE: localize me
        var strBundle = document.getElementById('stringBundle');
        alert(strBundle.getString("flock.photo.upload.error.3"));
        $('bcasterHasPhotos').setAttribute('label', 'upload');
        $('bcasterHasPhotos').setAttribute('oncommand', 'flock_photoLaunchUpload();');
        $('flockPhotoUploadProgress').removeAttribute('value'); 
        $('photoAddFilesBtn').removeAttribute('disabled');
        flock_photoUploadEnable();
    },
    onAuthStateChange: function (aState) {
        flock_photoUpdateEnabledness();
    }
}

////////////////////////////////////////////////////////////////////////////////////////
// Assorted UI
////////////////////////////////////////////////////////////////////////////////////////

function flock_photoWeHavePhotos() {
    return (flock_photoCount()!=0);
}

function flock_photoCount() {
    return ($("flock-photo-upload-slideybox").childNodes.length - 1);
}

function flock_photoUpdateEnabledness() {
    return;
    // XXX - this will set the UI states of the uploader window
    var svc = flock.photouploader.service;
    var statusmessage = $("flock-photoUploaderStatusText");
    
    if(svc.isUploading) {
        $("flock-photo-upload-button").setAttribute("label", "Cancel Upload");
        $("flock-photo-upload-button").setAttribute("oncommand", "flock_photoUploadCancel()");
        flock_photoUploadDisable();
    }
    else {
        $("flock-photo-upload-button").setAttribute("label", "Upload");
        $("flock-photo-upload-button").setAttribute("oncommand", "flock_photoUpload()");
        
        flock_photoUploadEnable();
    }

    if(flock_photoWeHavePhotos()) {
        // XXX - let's put these messages in the uploader statusbar?
        $("flock-photo-instructions").removeAttribute("hidden");
        // we will eventually animate this to slide up
        statusmessage.value= '';
    }
    else {
        $("flock-photo-instructions").setAttribute("hidden", true);
        var photo_count = $("flock-photo-upload-slideybox").childNodes.length - 1;
        if (photo_count > 1) {
           statusmessage.value = "You have " + photo_count + " photos to upload.";
        } else {
           statusmessage.value = "You have 1 photo to upload.";
        }
    }

    if(flock_photoWeHavePhotos()) {
        flock_photoUploadDisableButton();
    }
    else {
        flock_photoUploadEnableButton();
    }
}

function flock_photoUploadEnable() {
    $("flock-photo-upload-slideybox").enabled = true;
    $("flock-photo-disable").setAttribute("hidden", true);
}

function flock_photoUploadEnableButton() {
    $("flock-photo-upload-button").setAttribute("uploading", false);
    $("flock-photo-upload-button").removeAttribute("disabled");
}

function flock_photoUploadDisableButton() {
    $("flock-photo-upload-button").setAttribute("uploading", true);
    $("flock-photo-upload-button").setAttribute("disabled", true);
}

function flock_photoUploadDisable() {
    $("flock-photo-upload-slideybox").enabled = false;
    $("flock-photo-disable").removeAttribute("hidden");
}

function flock_photoUpload() {
    if($("flock-photo-upload-slideybox").enabled == true) { //that check isn't really valid anymore
        $("flock-photo-upload-slideybox").scrollHome();
        flock_photoUploadDisable();
        flock_photoDoUpload();
    } else {
        //gUploadListener.running = false;
        flock_photoUploadEnable();
    }
}

function flock_photoUploadCancel() {
    flock.photo.service.cancelUpload()
}

function flock_photoDoUpload() {
    var svc = flock.photouploader.service;

    if(svc.isLoggedIn()) {
        svc.upload();
    }
}

function flock_photoLoginEvent() {
}

function flock_photoLaunchUpload() {
    var params = {};
    params.photoUploads = flock_getAllPhotoUploads();
    var rv = window.openDialog("chrome://browser/content/flock/photo/flockPhotoUploadOptions.xul", "_blank", "modal,centerscreen", params);
    var pendingUploads = flock_getAllPhotoUploads();
    for (var i=0; i < pendingUploads.length; i++) {
        pendingUploads[i].album = params.albumId;
        gUploaderService.savePhotoUpload(pendingUploads[i]); 
    }
    gNumUploads = params.photoUploads.length;
    flock_photoUpload(params.apiName);
}



function flock_photoUpload(aApiShortname) {
    var api = gPhotoMgrSvc.getAPIFromShortname(aApiShortname);
    var svcinst = gUploaderService;
    var loginListener = new PhotoLoginListener();
    var strBundle = document.getElementById('stringBundle');
    
    loginListener.onAPIStateChange = function (aApi) {
        if (aApi.isLoggedIn) {
            svcinst.upload(api);
            gPhotoMgrSvc.removeListener(this);
            $('bcasterHasPhotos').removeAttribute('disabled');
        }
    }
    
    loginListener.onError = function (aError) {
        dump(aError.errorString + '\n');
    }
    
    if(api.isLoggedIn) {
        svcinst.upload(api);
    }

    else {
        alert(strBundle.getString('flock.photo.upload.prompt').replace('%1', api.serviceName));
        gPhotoMgrSvc.addListener(loginListener);
        gPhotoMgrSvc.doLogin(aApiShortname);
        $('bcasterHasPhotos').setAttribute('disabled', true);
        
    }
}

// this should be refactored to apprximately reflect a command updating model
// also, use of commands and broadcasters simultaneously is a bit awkward
function flock_updateSelectionUI() {
    if (!$("flock-photo-upload-slideybox").enabled)
         return;
    var selection = $("flock-photo-upload-slideybox").getSelection();
    if(selection && selection.length) {
        $('bcasterPhotosSelected').removeAttribute('disabled');
        $("flock-photoprops-disable").hidden = true;
        if(selection.length==1) {
            $("cmdCrop").removeAttribute("disabled");
        }
        else {
            $("cmdCrop").setAttribute("disabled", true);
            dump("DISABLING CROPPING\n");
        }
    } else {
        $('bcasterPhotosSelected').setAttribute('disabled', true);
        $("cmdCrop").setAttribute("disabled", true);
        $("flock-photoprops-disable").hidden = false;
    }
    
    flock_updateCommandState();
}

function flock_updateCommandState() {
    if(flock_photoWeHavePhotos()){
        if ($("flock-photo-upload-slideybox").enabled) {
            $('bcasterHasPhotos').removeAttribute('disabled');
        }
        $('flock-photo-instructions').setAttribute('hidden', true);
    }
    else {
        $('bcasterHasPhotos').setAttribute('disabled', true);
        $('flock-photo-instructions').removeAttribute('hidden');
        $("flock-photo-upload-slideybox").shouldFireSelect="true";
    }
}


const PREF_UPLOADER_INITIAL_FILEPATH = 'flock.photo.uploader.initialPath';

function flock_addPhotoFiles() {
    const nsIFilePicker = Components.interfaces.nsIFilePicker;
    var init_dir = Components.classes["@mozilla.org/file/local;1"].
            createInstance(Components.interfaces.nsILocalFile);
    var init_path_pref = flock_getCharPref(PREF_UPLOADER_INITIAL_FILEPATH);
    var photoUrls = Array();

    if (!init_path_pref) {
        var dirService = Components.classes["@mozilla.org/file/directory_service;1"]
                 .getService(Components.interfaces.nsIProperties);
                 
// platform specificness                 
//@line 404 "/cygdrive/K/tinderbuild/src/flock/mozilla/browser/components/flock/photo/content/photoUploadTopbar.js"
        // the code to the appdir directory service should be checked into mozilla that will
        // make the following line valid -- we hack till then
        //init_path_pref = dirService.get("Pct", Components.interfaces.nsIFile).path;
        
        // "My Documents"
        init_path_pref = dirService.get("DeskV", Components.interfaces.nsIFile).parent.path;
        init_path_pref = init_path_pref + "\\My Pictures";
//@line 416 "/cygdrive/K/tinderbuild/src/flock/mozilla/browser/components/flock/photo/content/photoUploadTopbar.js"
        
        init_dir.initWithPath(init_path_pref);
        
        if (init_dir.path && init_dir.path.length)
            init_path_pref = init_dir.path;
        
        flock_setCharPref(PREF_UPLOADER_INITIAL_FILEPATH, init_path_pref);
        
    } else {
        init_dir.initWithPath(init_path_pref);
    }

    
    
    var fp = Components.classes["@mozilla.org/filepicker;1"]
    	     .createInstance(nsIFilePicker);
    	
    fp.init(window, "Add photos", nsIFilePicker.modeOpenMultiple);
    fp.appendFilters(nsIFilePicker.filterAll);
  
    var homeDir = null;
    var mypicsPath = null;

    fp.displayDirectory = init_dir;
      
    if ( fp.show( ) == nsIFilePicker.returnOK && fp.files ) {
        var enum = fp.files;
        var item = null;
        var file = null;
        var path = null;  
        while (enum.hasMoreElements()) {
            item = enum.getNext();
            file = item.QueryInterface(Components.interfaces.nsIFile);
            path = file.path.toLowerCase();
            if (path.match(/.+jpg$/) ||
                 path.match(/.+jpeg$/)||
                 path.toLowerCase().match(/.+png$/) ||
                 path.toLowerCase().match(/.+gif$/)) 
                {
                    //flock.photo.util.handlePhotoDrop(flock_getURLFromFile(file), null, false);   
                    photoUrls.push(flock_getURLFromFile(file));
               }
       }       
        //flock.photo.util.processPhotoImportQueue();
        var dropProcessor = new PhotoDropProcessor(photoUrls, null); 
        dropProcessor.start();
        var lastSelectedDir  = file.path.substring(0, file.path.indexOf(file.leafName));
        flock_setCharPref(PREF_UPLOADER_INITIAL_FILEPATH, lastSelectedDir);
        $('flock-photo-instructions').setAttribute('hidden', true);
    }
}
       
