/*  *
 * ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code Shadows.com API client implementation.
 *
 * The Initial Developer of the Original Code is
 * Pluck Corporation. This code is Copyright (C) 2005, 2006
 * All Rights Reserved.
 *
 * Contributor(s):
 *   Carl Brown (carlb@shadows.com)
 *   Duane Fields (dfields@pluck.com)
 *
 * ***** END LICENSE BLOCK ***** */
 
 var averagerating = 0;
 
 function shadowsTagClick(aEvent, aListItem){
    var url = aListItem.getAttribute("value").split("||")[0];

    if ((aEvent.ctrlKey) || (aEvent.button == 1) || (aEvent.metaKey)){
	var tbrowser = top.document.getElementById("content");
	tbrowser.addTab(url);
    } else {
	top.content.document.location = url;
    }
}

function flock_shadowsTopbarPageInit() {
    dump('flock_shadowsTopbarPageInit()');
    window.addEventListener('load', flock_shadowsTopbarPageReload, false);
    flock_shadowsTopbarPageReload();
}

function flock_shadowsTopbarPageReload() {
    dump('flock_shadowsTopbarPageReload()');
    shadowPagePopulate(window.top.content.document.location.toString(),
                         $$("content").mCurrentBrowser.contentWindow.document.title + "");
}

function shadowTagsShow(aUrlStats) {
    dump('shadowTagsShow firing, tags.\n');
    
    rateblock = $("shadowpage-averagerating");
    userBlock = $("shadowpage-firstUser");
    rateblock.src='chrome://browser/content/flock/topbar/shadowsStars' + aUrlStats['SummaryList'][0]['CurrentRating'] + '.gif';
    rateblock.height=12;
    if (aUrlStats['SummaryList'].length >= 1) {
        var futureDate = new Date();
        futureDate.setFullYear(2030,0,1); //long way off
        var pastDate = new Date();
        pastDate.setFullYear(2000,0,1); //before Shadows Started
        if ((aUrlStats['SummaryList'][0]['FirstAction'] > futureDate) || (aUrlStats['SummaryList'][0]['FirstAction'] < pastDate)){
            //This is what we get back if no one has starred it yet
            userBlock.value = "Be the first to star this page.  Get your name here.";
        } else {
            var who = aUrlStats['SummaryList'][0]['FirstActionUserName'];
            var when = aUrlStats['SummaryList'][0]['FirstAction'] + " ";
            var regExp = /[A-Z][a-z][a-z]\s(.*)\s\s*([0-9][0-9]*\:[0-9][0-9]*)\:[0-9]*\sGMT.*$/;
            when = when.replace(regExp, "$2 on $1");
            if (who == "") {
                who = "Anonymous";
            }
            userBlock.value='First Starred by "' + who + '" at ' + when; 
        }
    }  else {
        userBlock.value = "Be the first to star this page.  Get your name here.";
    }
    tagCountBlock = $("shadowpage-tagCount");
    if (aUrlStats['SummaryList'].length >=1) {
        tagCountBlock.value='('+aUrlStats['SummaryList'][0]['TagCount']+')';
    } else { tagCountBlock.value=0; }
            
    var tagCloud = $("flock-shadows-topbar-tags");
    // Clear the list
    var items = tagCloud.getElementsByTagName('listitem');
    while(items.length > 0) {
	    tagCloud.removeChild(items[0]);
    }

    var tagArray = new Array();
    function sortTags (a, b) {
        dump('comparing "'+a['Tag']+'" and "'+b['Tag']+'"\n');
        if (a['Tag'].toLowerCase() > b['Tag'].toLowerCase()) {
            return 1;
        }
        if (a['Tag'].toLowerCase() < b['Tag'].toLowerCase()) {
            return -1;
        }
        return 0;
    }

    if (aUrlStats['SummaryList'].length >=1) {
        tagArray = aUrlStats['SummaryList'][0]['Tags'];
        tagArray.sort(sortTags);
        var minTagCount=tagArray[0]['Weight'];
        var maxTagCount=tagArray[0]['Weight'];
        //make a pass and get min and max counts
        for (i=0; i < tagArray.length; i++) {
            if (minTagCount > tagArray[i]['Weight'])
                minTagCount=tagArray[i]['Weight'];
            if (maxTagCount < tagArray[i]['Weight'])
                maxTagCount=tagArray[i]['Weight'];
        }
        var tagCountRange = maxTagCount-minTagCount;
        var fontWeightRange = 18 - 10;
        for (i=0; i < tagArray.length; i++) {
            var tag = tagArray[i]['Tag'];
            var weight = tagArray[i]['Weight'];
            var url = 'http://www.shadows.com/search.aspx?keyword=' + tag + '&sourceid=flock-search';
            var thisItem = tagCloud.appendItem(tag, url);// + '('+weight+'-'+Math.floor(((weight*fontWeightRange)/tagCountRange) + 10)+')', url);
            thisItem.setAttribute('class', 'shadowpage-font' + (Math.floor((weight*fontWeightRange)/tagCountRange) + 10));
        }
    }
}

function shadowCommentsShow(aUrlComments) {
    dump('shadowTagsShow firing, comments.\n');
    var commentList = $("flock-shadows-topbar-comments");
    // Clear the list
    var items = commentList.getElementsByTagName('listitem');
    while(items.length > 0) {
	    commentList.removeChild(items[0]);
    }
    commentCountBlock = $("shadowpage-commentCount");
    if (aUrlComments['CommentList'].length >= 1) {
        commentCountBlock.value='('+aUrlComments['CommentList'][0]['Comments'].length+')'; 
    } else { commentCountBlock.value="(0)"; }
    
    if (aUrlComments['CommentList'].length >= 1) {
        for (i=0; i < aUrlComments['CommentList'][0]['Comments'].length; i++) {
            var user = aUrlComments['CommentList'][0]['Comments'][i]['Username'];
            if (user == "") {
                user = "Anonymous";
            }
            var comment = aUrlComments['CommentList'][0]['Comments'][i]['Comment'];
            var url = aUrlComments['CommentList'][0]['Comments'][i]['Permalink'];
            if (url.indexOf('?') == -1) {
                url = url + '?sourceid=flock-search';
            } else {
                url = url + '&sourceid=flock-search';
            }
            var count = aUrlComments['CommentList'][0]['Comments'][i]['ReplyCount'];
            var when = aUrlComments['CommentList'][0]['Comments'][i]['ActionAt'] + "";
            var regExp = /[A-Z][a-z][a-z]\s(.*)\s\s*([0-9][0-9]*\:[0-9][0-9]*)\:[0-9]*\sGMT.*$/;
            when = when.replace(regExp, "$2 on $1")
            commentList.appendItem(comment, url);
            var metaCommentInfo = commentList.appendItem('Posted by: '+user+' at '+when, "http://www.shadows.com/users/" + user + '?sourceid=flock-search');
            metaCommentInfo.setAttribute('class', 'shadowpage-metaCommentInfo');
        }
    }
}


function shadowPagePopulate(aURL, aTitle) {
    pageTitle = $("shadowpage-title");
    pageTitle.value=aTitle;    

    if(aURL.match("http://")){
        var listenerStats = new Object ();
        listenerStats.onResult = function (aResult) {
            dump("listenerStats.onResult");
            shadowTagsShow(aResult);
        }
        listenerStats.onFault = function (aFaultCode, aFaultString) {
            dump('listenerStats.onFault aFaultCode "'+aFaultCode+'" aFaultString "'+aFaultString+'"\n');
            fault=aMessage;
        }
        listenerStats.onError = function (aMessage) {
            dump('listenerStats.onError aMessage "'+aMessage+'"\n');
            fault=aMessage;
        }
        shadows.getInfoForUrl ([aURL], listenerStats);

        var urlComments = null;
        var listenerComments = new Object ();
        listenerComments.onResult = function (aResult) {
            dump("listenerComments.onResult");
            shadowCommentsShow(aResult);
        }
        listenerComments.onFault = function (aFaultCode, aFaultString) {
            dump('listenerComments.onFault aFaultCode "'+aFaultCode+'" aFaultString "'+aFaultString+'"\n');
            fault=aMessage;
        }
        listenerComments.onError = function (aMessage) {
            dump('listenerComments.onError aMessage "'+aMessage+'"\n');
            fault=aMessage;
        }
        shadows.getCommentsForUrl ([aURL], listenerComments);
    }
}
